Subject: bug#13348: 24.3.50; `C-s', `C-r', `RET' in `minibuffer-local-isearch-map'

From: Juri Linkov <[email-masked]>
Date: Tue, 07 May 2013 11:49:18 +0300

>> Is this what you expected?
>
>>  (defun isearch-forward-exit-minibuffer ()
>> +  "Resume isearching forward."
>>
>>  (defun isearch-reverse-exit-minibuffer ()
>> +  "Resume isearching backward."
>
> Sure, but why not say also what the searching is resuming _from_?

It would be more helpful if you wrote these docstrings
as you want instead of explaining your wishes.
Now I added your additions below.

Also I noticed that `isearch-nonincremental-exit-minibuffer'
has no effect, so I removed it instead of adding a docstring
to this unused function:

=== modified file 'lisp/isearch.el'
--- lisp/isearch.el	2013-05-01 08:10:12 +0000
+++ lisp/isearch.el	2013-05-07 08:48:31 +0000
@@ -528,7 +528,7 @@ (defvar isearch-mode-map
 (defvar minibuffer-local-isearch-map
   (let ((map (make-sparse-keymap)))
     (set-keymap-parent map minibuffer-local-map)
-    (define-key map "\r"    'isearch-nonincremental-exit-minibuffer)
+    (define-key map "\r"    'exit-minibuffer)
     (define-key map "\M-\t" 'isearch-complete-edit)
     (define-key map "\C-s"  'isearch-forward-exit-minibuffer)
     (define-key map "\C-r"  'isearch-reverse-exit-minibuffer)
@@ -1273,7 +1274,6 @@ (defun isearch-edit-string ()
 The following additional command keys are active while editing.
 \\<minibuffer-local-isearch-map>
 \\[exit-minibuffer] to resume incremental searching with the edited string.
-\\[isearch-nonincremental-exit-minibuffer] to do one nonincremental search.
 \\[isearch-forward-exit-minibuffer] to resume isearching forward.
 \\[isearch-reverse-exit-minibuffer] to resume isearching backward.
 \\[isearch-complete-edit] to complete the search string using the search ring."
@@ -1303,17 +1303,14 @@ (defun isearch-edit-string ()
 	   (mapconcat 'isearch-text-char-description
 		      isearch-new-string "")))))
 
-(defun isearch-nonincremental-exit-minibuffer ()
-  (interactive)
-  (setq isearch-nonincremental t)
-  (exit-minibuffer))
-
 (defun isearch-forward-exit-minibuffer ()
+  "Resume isearching forward from the minibuffer that edits the search string."
   (interactive)
   (setq isearch-new-forward t)
   (exit-minibuffer))
 
 (defun isearch-reverse-exit-minibuffer ()
+  "Resume isearching backward from the minibuffer that edits the search string."
   (interactive)
   (setq isearch-new-forward nil)
   (exit-minibuffer))